<template>
  <div class="app-container">
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['system:equip:add']"
          >新增</el-button
        >
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['system:equip:edit']"
          >修改</el-button
        >
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['system:equip:remove']"
          >删除</el-button
        >
      </el-col>
    </el-row>

    <el-table
      v-loading="loading"
      :data="equipList"
      @selection-change="handleSelectionChange"
    >
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="" align="center" prop="id" />
      <el-table-column label="传感器编号" align="center" prop="sensorNum" />
      <el-table-column label="点位名称" align="center" prop="pointName" />
      <el-table-column label="监测类型" align="center" prop="monitorType" />
      <el-table-column label="监测项名称" align="center" prop="items" />
      <el-table-column label="一级预警" align="center" prop="onelevelalarm" />
      <el-table-column label="二级预警" align="center" prop="twolevelalarm" />
      <el-table-column label="三级预警" align="center" prop="threelevelalarm" />
      <el-table-column label="四级预警" align="center" prop="fourlevelalarm" />
      <el-table-column label="数量单位" align="center" prop="unit" />
      <el-table-column
        label="操作"
        align="center"
        class-name="small-padding fixed-width"
      >
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['system:equip:edit']"
            >修改</el-button
          >
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['system:equip:remove']"
            >删除</el-button
          >
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改环境监测设备信息对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="传感器编号" prop="sensorNum">
          <el-input v-model="form.sensorNum" placeholder="请输入传感器编号" />
        </el-form-item>
        <el-form-item label="点位名称" prop="pointName">
          <el-input v-model="form.pointName" placeholder="请输入点位名称" />
        </el-form-item>
        <el-form-item label="监测项名称" prop="items">
          <el-input v-model="form.items" placeholder="请输入监测项名称" />
        </el-form-item>
        <el-form-item label="一级预警" prop="onelevelalarm">
          <el-input v-model="form.onelevelalarm" placeholder="请输入一级预警" />
        </el-form-item>
        <el-form-item label="二级预警" prop="twolevelalarm">
          <el-input v-model="form.twolevelalarm" placeholder="请输入二级预警" />
        </el-form-item>
        <el-form-item label="三级预警" prop="threelevelalarm">
          <el-input
            v-model="form.threelevelalarm"
            placeholder="请输入三级预警"
          />
        </el-form-item>
        <el-form-item label="四级预警" prop="fourlevelalarm">
          <el-input
            v-model="form.fourlevelalarm"
            placeholder="请输入四级预警"
          />
        </el-form-item>
        <el-form-item label="数量单位" prop="unit">
          <el-input v-model="form.unit" placeholder="请输入数量单位" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  listEquip,
  getEquip,
  delEquip,
  addEquip,
  updateEquip,
} from "@/api/envi/equip";
import { listPoint } from "@/api/envi/point";
export default {
  name: "Equip",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 环境监测设备信息表格数据
      equipList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        sensorNum: null,
        pointName: null,
        monitorType: null,
        items: null,
        onelevelalarm: null,
        twolevelalarm: null,
        threelevelalarm: null,
        fourlevelalarm: null,
        unit: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {},
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询环境监测设备信息列表 */
    getList() {
      this.loading = true;
      listEquip(this.queryParams).then((response) => {
        this.equipList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        sensorNum: null,
        pointName: null,
        monitorType: null,
        items: null,
        onelevelalarm: null,
        twolevelalarm: null,
        threelevelalarm: null,
        fourlevelalarm: null,
        unit: null,
        createTime: null,
        updateTime: null,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.id);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加环境监测设备信息";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids;
      getEquip(id).then((response) => {
        this.form = response.data;
        this.open = true;
        this.title = "修改环境监测设备信息";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate((valid) => {
        if (valid) {
          if (this.form.id != null) {
            updateEquip(this.form).then((response) => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addEquip(this.form).then((response) => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal
        .confirm('是否确认删除环境监测设备信息编号为"' + ids + '"的数据项？')
        .then(function () {
          return delEquip(ids);
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        })
        .catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download(
        "system/equip/export",
        {
          ...this.queryParams,
        },
        `equip_${new Date().getTime()}.xlsx`
      );
    },
  },
};
</script>
